---
include:
  - project: kits-maxiv/kubernetes/k8s-gitlab-ci
    file: "/Docker-Helm-deploy.gitlab-ci.yml"
    ref: "0.7"

variables:
  HELM_CHART_NAME: maxiv-archviewer
  HELM_RELEASE_NAMESPACE_TEST: archviewer
  HELM_RELEASE_NAMESPACE_PROD: archviewer
  PIPELINES_FF_TOKENIZER: "true"
  PRODUCTION_BRANCH_NAME: "main"
  PRODUCTION_DEPLOY_ON_TAG: "true"
  HELM_SET_PROD_ingress_host: "archviewer.maxiv.lu.se"
  HELM_SET_TEST_ingress_host: "archviewer-test-${CI_COMMIT_BRANCH}.apps.okdev.maxiv.lu.se"
  HELM_SET_PROD_image_tag: "__from_env_var:REGISTRY_IMAGE_TAG"
  HELM_SET_TEST_image_tag: "__from_env_var:REGISTRY_IMAGE_TAG"
  GITLAB_ENVIRONMENT_NAME: archviewer

# Override workflow rules to deploy on any branch
workflow:
  rules:
    - if: '$CI_COMMIT_BRANCH'
    - if: '$CI_COMMIT_TAG'

image:
  # name: mcr.microsoft.com/playwright/python:v1.39.0-jammy  # Image preloaded with browsers
  name: node:20-bookworm
  entrypoint: [ '/bin/bash', '-c', 'ln -snf /bin/bash /bin/sh && /bin/bash -c $0' ]
      
pytest:
  stage: test
  tags:
    - docker  # The browser test don't work properly in kubernetes, don't know why
  before_script:
    - npx -y playwright@1.50.1 install --with-deps
    - npm install
    - node_modules/esbuild/bin/esbuild frontend/index.js --outfile=static/out.js --bundle
    - apt-get install -y python3-pip python3-venv
    - python3 -m venv env
    - env/bin/pip install .[tests]
    - env/bin/playwright install --with-deps
    - env/bin/pip install -e .
  script:
    env/bin/pytest --browser firefox -v --junitxml=report.xml
  artifacts:
    when: always
    reports:
      junit: report.xml
